<template>
  <section class="page-cdb-result">
    <div v-if="result.history.length > 0">
      <nav class="level mb-6">
        <div class="level-item has-text-centered">
          <div>
            <p class="heading">Fator</p>
            <p class="title has-text-primary animate__bounceIn">
              {{ result.factor }}
            </p>
          </div>
        </div>
        <div class="level-item has-text-centered">
          <div>
            <p class="heading">Taxa</p>
            <p class="title has-text-primary animate__bounceIn">
              {{ result.cdiRate | percent }}
            </p>
          </div>
        </div>
        <div class="level-item has-text-centered">
          <div>
            <p class="heading">Valor calculado</p>
            <p class="title has-text-primary animate__bounceIn">
              R$ {{ result.finalValue | finance }}
            </p>
          </div>
        </div>
      </nav>

      <div class="page-cdb-result__table mb-6">
        <div class="columns">
          <div class="column">
            <gw-cdb-calculate-chart />
          </div>
          <div class="column">
            <gw-table
              :data="result.history"
              height="330"
              default-sort="date"
              default-sort-direction="desc"
              per-page="10"
              paginated
              pagination-simple
              striped
              hoverable
              sticky-header>
              <template slot-scope="props">
                <gw-table-column
                  field="date"
                  label="Data"
                  sortable>
                  {{ props.row.date | date }}
                </gw-table-column>
                <gw-table-column
                  field="unitPrice"
                  label="Valor calculado"
                  sortable
                  numeric>
                  R$ {{ props.row.unitPrice | finance }}
                </gw-table-column>
              </template>
            </gw-table>
          </div>
        </div>
      </div>
    </div>
    <gw-empty v-else></gw-empty>
  </section>
</template>

<script>
import { createNamespacedHelpers } from 'vuex';
import GwEmpty from '@/components/gw-empty/GwEmpty.vue';
import GwTable from '@/components/gw-table/GwTable.vue';
import GwTableColumn from '@/components/gw-table/GwTableColumn.vue';
import GwCdbCalculateChart from './GwCdbCalculateChart.vue';

const { mapState, mapGetters } = createNamespacedHelpers('cdbCalculate');

export default {
  name: 'GwCdbCalculateResult',
  computed: {
    ...mapState([
      'form',
      'result',
    ]),
    ...mapGetters([
      'lastPrice',
    ]),
  },
  components: {
    GwEmpty,
    GwTable,
    GwTableColumn,
    GwCdbCalculateChart,
  },
};
</script>

<style lang="scss" scoped>
  @import "~bulma/sass/utilities/_all";

  .page-cdb-result{
    &__table{
      border: 1px solid $primary;
      border-radius: 10px;
      padding: 2rem 1rem;
    }
  }
</style>
